dimtest<-function(X)
{
  dims<-dim(X)
  n<-dims[1]
  p<-dims[2]
  S<-cov(X)
  D<-eigen(S,only.values=TRUE)$values
  logD<-log(D)
  result<-NULL
  for(k in seq(p-2,0,-1))
  {
    t<-(n-(2*p+11)/6)*((p-k)*log(sum(D[(k+1):p])/(p-k))-sum(logD[(k+1):p]))
    df<-(p-k-1)*(p-k+2)/2
    result<-rbind(result, c(p-k, round( c(t,1-pchisq(t,df)) ,4) ))
  }
  return(result)
}


